package org.jeecg.modules.sensor.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.device.entity.BuDevice;
import org.jeecg.modules.device.service.IBuDeviceService;
import org.jeecg.modules.sensor.entity.BuSensor;
import org.jeecg.modules.sensor.entity.BuStatus;
import org.jeecg.modules.sensor.entity.Modbustcppar;
import org.jeecg.modules.sensor.service.IBuSensorService;
import org.jeecg.modules.sensor.service.IBuStatusService;
import org.jeecg.modules.sensor.service.IModbustcpparService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;

 /**
 * @Description: modbustcppar
 * @Author: jeecg-boot
 * @Date:   2024-10-15
 * @Version: V1.0
 */
@Api(tags="modbustcppar")
@RestController
@RequestMapping("/sensor/modbustcppar")
@Slf4j
public class ModbustcpparController extends JeecgController<Modbustcppar, IModbustcpparService> {
	@Autowired
	private IModbustcpparService modbustcpparService;
	@Autowired
	private IBuSensorService buSensorService;
	@Autowired
	private IBuDeviceService buDeviceService;
	@Autowired
	private IBuStatusService buStatusService;
	/**
	 * 分页列表查询
	 *
	 * @param modbustcppar
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "modbustcppar-分页列表查询")
	@ApiOperation(value="modbustcppar-分页列表查询", notes="modbustcppar-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<Modbustcppar>> queryPageList(Modbustcppar modbustcppar,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<Modbustcppar> queryWrapper = QueryGenerator.initQueryWrapper(modbustcppar, req.getParameterMap());
		Page<Modbustcppar> page = new Page<Modbustcppar>(pageNo, pageSize);
		IPage<Modbustcppar> pageList = modbustcpparService.page(page, queryWrapper);
		for (Modbustcppar record : pageList.getRecords()) {
			BuSensor buSensor = buSensorService.getById(record.getSensorId());
			if(buSensor != null) {
				BuDevice buDevice = buDeviceService.getById(buSensor.getDeviceId());
				record.setDeviceName(buDevice.getDeviceName()+buDevice.getDeviceCode());
				record.setSensorName(buSensor.getName());
				BuStatus buStatus = buStatusService.getDataBySensorId(buSensor.getId());
				record.setSensorStatus(buStatus.getSensorStatus());

			}
		}
		if(modbustcppar.getDeviceName()!=null){
			try
			{
//				List<Modbustcppar> collect = pageList.getRecords().stream().filter(e -> e.getDeviceName().contains(modbustcppar.getDeviceName())).collect(Collectors.toList());
//				pageList.setRecords(collect);

				List<Modbustcppar> collect = pageList.getRecords().stream()
						.filter(e -> {
							String targetName = modbustcppar.getDeviceName();
							return targetName != null && e.getDeviceName() != null && e.getDeviceName().contains(targetName);
						})
						.collect(Collectors.toList());
				pageList.setRecords(collect);
			}
			catch (Exception e)
			{
				System.out.println("即时保存.rowData：" +e.getMessage());
			}
		}
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param modbustcppar
	 * @return
	 */
	@AutoLog(value = "modbustcppar-添加")
	@ApiOperation(value="modbustcppar-添加", notes="modbustcppar-添加")
	//@RequiresPermissions("org.jeecg.modules.demo:modbustcppar:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody Modbustcppar modbustcppar) {
		modbustcpparService.save(modbustcppar);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param modbustcppar
	 * @return
	 */
	@AutoLog(value = "modbustcppar-编辑")
	@ApiOperation(value="modbustcppar-编辑", notes="modbustcppar-编辑")
	//@RequiresPermissions("org.jeecg.modules.demo:modbustcppar:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody Modbustcppar modbustcppar) {
		modbustcpparService.updateById(modbustcppar);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "modbustcppar-通过id删除")
	@ApiOperation(value="modbustcppar-通过id删除", notes="modbustcppar-通过id删除")
	//@RequiresPermissions("org.jeecg.modules.demo:modbustcppar:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		modbustcpparService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "modbustcppar-批量删除")
	@ApiOperation(value="modbustcppar-批量删除", notes="modbustcppar-批量删除")
	//@RequiresPermissions("org.jeecg.modules.demo:modbustcppar:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.modbustcpparService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "modbustcppar-通过id查询")
	@ApiOperation(value="modbustcppar-通过id查询", notes="modbustcppar-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<Modbustcppar> queryById(@RequestParam(name="id",required=true) String id) {
		Modbustcppar modbustcppar = modbustcpparService.getById(id);
		if(modbustcppar==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(modbustcppar);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param modbustcppar
    */
    //@RequiresPermissions("org.jeecg.modules.demo:modbustcppar:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, Modbustcppar modbustcppar) {
        return super.exportXls(request, modbustcppar, Modbustcppar.class, "modbustcppar");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    //@RequiresPermissions("modbustcppar:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, Modbustcppar.class);
    }

}
